/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.SettingDataFixedDto;
import com.portofolio.service.SettingDataFixedMasterService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;

@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/settingDataFixed")
public class SettingDataFixedController extends LocaleController {

	@Lazy
	@Autowired
	private SettingDataFixedMasterService settingDataFixedService;

	
	@ApiOperation("Api Untuk Menyimpan SettingDataFixed")
	@PostMapping("/save")
	public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody SettingDataFixedDto entity, HttpServletRequest request) {
		Map<String, Object> result = settingDataFixedService.save(entity);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Update SettingDataFixed")
	@PutMapping("/update")
	public ResponseEntity<Map<String, Object>> update(@RequestParam(value = "version", required = true) Integer version,
			@Valid @RequestBody SettingDataFixedDto entity, HttpServletRequest request) {
		Map<String, Object> result = settingDataFixedService.update(entity, version);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Hapus Berdasarkan namaField")
	@DeleteMapping("/delete")
	public ResponseEntity<Map<String, Object>> deleteById(
			@RequestParam(value = "namaField", required = true) String namaField,
			@RequestParam(value = "version", required = true) Integer version) {
		Map<String, Object> result = settingDataFixedService.deleteById(namaField, version);
		
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menampilkan Semua SettingDataFixed")
	@GetMapping("/grid")
	public ResponseEntity<Map<String, Object>> grid(@RequestParam(value = "page", defaultValue = "1") Integer page,
			@RequestParam(value = "rows", defaultValue = "10") Integer rows,
			@RequestParam(value = "dir", defaultValue = "id.namaField") String dir,
			@RequestParam(value = "sort", defaultValue = "desc") String sort,
			@RequestParam(value = "namaField", required = false) String namaField,
			@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
		Map<String, Object> result = settingDataFixedService.grid(page, rows, sort, dir, namaField,statusEnabled);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menampilkan Field Berdasarkan nama Tabel")
	@GetMapping("/findFieldFromSelectedTabel")
	public ResponseEntity<Map<String, Object>> findFieldFromSelectedTabel(
			@RequestParam(value = "namaTabel", required = true) String namaField,
			HttpServletRequest request) {
		Map<String, Object> result = settingDataFixedService.findFieldFromSelectedTabel(namaField);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menampilkan Semua Tabel Master")
	@GetMapping("/findTabel")
	public ResponseEntity<Map<String, Object>> findTabel() {
		Map<String, Object> result = settingDataFixedService.getListTable();
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menampilkan Primary Key Tabel berdasarkan nama tabel")
	@GetMapping("/findPrimaryKeyFieldFromSelectedTable")
	public ResponseEntity<Map<String, Object>> findPrimaryKeyFieldFromSelectedTable(@RequestParam(value = "tabelName", required = true) String tabelName,
			HttpServletRequest request) {
		Map<String, Object> result = settingDataFixedService.findPrimaryKeyFieldFromSelectedTable(tabelName);
		return RestUtil.getJsonResponse(result);
	}

	
	@ApiOperation("Api Untuk Menampilkan data Berdasarkan field")
	@GetMapping("/findDataFromSelectedTableAndField")
	public ResponseEntity<Map<String, Object>> findDataBy(@RequestParam(value = "tabelName") String tabelName,
			@RequestParam(value = "fieldKeyTabelRelasi", required = false) String field1,
			@RequestParam(value = "fieldReportDisplayTabelRelasi", required = false) String field2) {
		Map<String, Object> result = settingDataFixedService.findDataFromSelectedTableAndField(tabelName, field1, field2);
		return RestUtil.getJsonResponse(result);
	}
	
	
	@ApiOperation("Api Untuk Menampilkan SettingDataFixed Berdasarkan namaField")
	@GetMapping("/findByNamaField")
	public ResponseEntity<Map<String, Object>> findByNamaField(
			@RequestParam(value = "namaField", required = true) String namaField) {
		Map<String, Object> result = settingDataFixedService.findByNamaField(namaField);
		
		return RestUtil.getJsonResponse(result);
	}
}
